# Instructions

## Instance extraction and preprocessing

- RSNA: the slices were preprocessed following this notebook: https://github.com/YunanWu2168/SA-MIL/blob/master/SA_MIL_preprocessing.ipynb. To obtain the features from the RSNA slices we used the script `extract_features.py`.
- PANDA: to extract the patches from the PANDA WSIs we used the scripts in https://github.com/arneschmidt/panda_scripts/tree/main/src. To obtain the features from the patches we used the script `extract_features.py`.
- CAMELYON16: to extract the patches and features from the CAMELYON16 WSIs we used the tool provided by CLAM (https://github.com/mahmoodlab/CLAM). The Resnet50 weights we used can be found here: https://github.com/lunit-io/benchmark-ssl-pathology/releases/tag/pretrained-weights. To extract the label of each patch we used the script `extract_labels.py`.

## Localization and classification results

We provide the code to reproduce the results for our models (SmAP and SmTAP).
We also provide the code to reproduce the results for CAMIL since no official code is available. Please run the the scripts in the `bash_scripts` folder to reproduce the results.

The code for the rest of the methods can be found in the corresponding repositories:
- CLAM: https://github.com/mahmoodlab/CLAM
- DSMIL: https://github.com/binli123/dsmil-wsi
- DFTD-MIL: https://github.com/hrzhang1123/DTFD-MIL
- TransMIL: https://github.com/szc19990412/TransMIL
- SETMIL: https://github.com/TencentAILabHealthcare/SETMIL/
- GTP: https://github.com/vkola-lab/tmi2022


    